#ifndef VECTOR3D_INCLUDED
 #define VECTOR3D_INCLUDED
#include <math.h>

// Quickly hacked from previous work; not pretty.

typedef double Component;

class Vect3d  
{
public:
	Component x;
	Component y;
	Component z;
public:
	void normalise(void) { scalarprod(1 / magnitude()); }
	void scalarprod(Component n) { x *= n; y *= n; z *= n; }
	Component magnitude() const { return sqrt(magnitudeSquared()); }
	Component magnitudeSquared() const { return (x*x) + (y*y) + (z*z); }
	Vect3d() : x(0), y(0), z(0) { }
	Vect3d(Component a, Component b, Component c) : x(a), y(b), z(c) { }
	Vect3d operator + (const Vect3d &b) const {
		return Vect3d(x+b.x, y+b.y, z+b.z);
	}
	/* subtraction */
	Vect3d operator - (const Vect3d &b) const {
		return Vect3d(x - b.x, y - b.y, z - b.z);
	}
	/* Unary - */
	Vect3d operator - () const {
		return Vect3d(-x, -y, -z);
	}
	/* Vector cross product */
	Vect3d operator * (const Vect3d &b) const;
	/* scalar product */
    	Vect3d operator * (Component s) const {
		return Vect3d(x * s, y * s, z * s);
	}
	/* dot product */
	Component dotProduct(const Vect3d &b) const {
		return (x * b.x) + (y * b.y) + (z * b.z);
	}
};

inline Component toRadians(Component deg)
{
	return (deg / 180) * M_PI;
}

inline Component toDegrees(Component rad)
{
	return (rad / M_PI) * 180;
}

#endif // VECTOR3D_INCLUDED
